/*
  Copyright Earth People Technology Inc. 2018
  
  TMP102 I2C Temperature Sensor
  
  Platform: Arduino Uno
    
*/

//Include the I2C Library
#include <Wire.h>

//Declare some int variables for use in the Loop()
int Channel;
int LoopCount;
int TemperatureValue;
float TemperatureFloat;



void setup() 
{

  // join i2c bus (address optional for master)
  Wire.begin(); 
  Serial.begin(115200);          // start serial communication at 9600bps
  
  // Set the Analog 0 signal as an input
  pinMode (0, INPUT);
  
  LoopCount = 0;
  Channel = 0;
  TemperatureValue = 0;
  
  Serial.println("TMP102 Temperature Sensor Active!");
  

}

void loop() 
{
  //Set the LoopCount to zero
  LoopCount = 0;
  
  //Begin transmit to device #144 (0x90)
  Wire.beginTransmission(72); 

  // sets register pointer to the command register (0x00)
  Wire.write(0x00);        

  // stop transmitting 
  Wire.endTransmission(); 

  //Send request 2 bytes from slave device #34
  Wire.requestFrom(72, 2);    

  // if two bytes were received
  if(2 <= Wire.available())    
  {
    // receive high byte 
    TemperatureValue = Wire.read()<<4;  
    //Read lower byte 
    TemperatureValue |= Wire.read()>>4;

  // Temperature data can be + or -, if it should be negative,
  // convert 12 bit to 16 bit and use the 2s compliment.
  if(TemperatureValue > 0x7FF)
  {
      TemperatureValue |= 0xF000;
  }
  // Convert digital reading to analog temperature (1-bit is equal to 0.0625 C)
  TemperatureFloat = TemperatureValue*0.0625;

  
  //Write the block of data to the Serial Port
    Serial.println(TemperatureFloat);

  
  }

  
  delay(500);
  
}

